/************************************************************/
/*                                                          */
/*             CFG TRANSFER TOOL DB <-> FILE                */
/*                                                          */
/************************************************************/
/*                                                          */
/*      MODULE     : CfgTransfer.c                          */
/*      AUTHOR     : F. BELLACHIA                           */
/*      LABORATORY : L.A.P.P.                               */
/*      VERSION    : v3r0                                   */
/*      DATE       : 08/08/01                               */
/*                                                          */
/************************************************************/
/*                                                          */
/*      MODIFICATION:                                       */
/*                                                          */
/************************************************************/
/*                                                          */
/*                                                          */
/************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <CfgVirgo.h>


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/
/*---------------------------------------------------------------- CfgDbUsage */
/*----------------------------------------------------------------------------*/
void CfgDbUsage( void ) {
  /*--------------------------------------------------------------------------*/
  printf("CfgDb usage:\n");
  printf("  CfgDb <dbTag> <filenane>.<extension>: load the <dbTag> DbObject "
	 "content in the <filename>.<extension> file\n" );
  printf("  CfgDb <filename>.<extension> <dbTag>: Commit the <filename>."
	 "<extension> content in the <dbTag> DbObject\n\n");
  exit( EXIT_FAILURE );
  /*--------------------------------------------------------------------------*/
  return;
}


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/
int main( int argc, char *argv[] ) {
  CfgData_t  *cfg;

  if( (argc != 3) || 
      (CfgFromFile( argv[1] ) == CfgFromFile( argv[2] )) ) CfgDbUsage();
  /*------------------------------------------------------- Cm Initialization */
  if( !CmMessageOpenMultipleServer(CfgBasename(argv[0])) ) {
    fprintf( stderr, "%s> CmMessageOpenMultipleServer failed\n", 
	     CfgBasename(argv[0]));
    exit( EXIT_FAILURE );
  }
  cfg = CfgDataNew( 0, NULL, 0 ); 
  /*------------------------------------------ Fill the CfgData strTime field */
  CfgDataGetStartTime( cfg );
  CbfCleanInstallPrinter((CbfCleanPrinter_t)NULL);

  /*--------------------------------------------------------------------------*/
  if( CfgFromFile( argv[1] ) ) { /*---------- Load from file and commit to Db */
    CfgConfigLoad( argv[1] ); 
    CfgDataSetNoFileSave( cfg, CfgTrue );
    CfgConfigCommit( argv[2] );
  }
  if( CfgFromFile( argv[2] ) ) { /*---------- Load from Db and commit to file */
    CfgConfigLoad( argv[1] );
    CfgDataSetNoDbSave( cfg, CfgTrue ); 
    CfgConfigCommit( argv[2] );
  }
  /*--------------------------------------------------------------------------*/
  exit( EXIT_SUCCESS );
}
